/* Copyright (c) 2002 Omar Kilani.  All rights reserved.
 *
 * This file is part of moodns.
 *
 * moodns is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * moodns is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with moodns; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Header: /cvsroot/moodns/moodns/code/sockcat/byte_array.h,v 1.1 2002/07/20 16:46:58 mawolf Exp $  */

#ifndef _REENTRANT
#define _REENTRANT
#endif

#ifndef BYTE_ARRAY_H
#define BYTE_ARRAY_H

#include "misc.h"

typedef struct {
    u8 *data;
    size_t len;
} byte_array;

size_t byte_array_cat(byte_array * orig, byte_array * tail);
size_t byte_array_cats(byte_array * orig, const u8 * data, size_t len);
size_t byte_array_catu8(byte_array * orig, u8 i);
size_t byte_array_catu16(byte_array * orig, u16 i);
size_t byte_array_catu32(byte_array * orig, u32 i);
size_t byte_array_insert(byte_array * orig, size_t idx, byte_array * insert);
size_t byte_array_inserts(byte_array * orig, size_t idx, u8 * data, size_t len);

size_t byte_array_replace(byte_array * orig, size_t idx, byte_array * replace);
size_t byte_array_replaces(byte_array * orig, size_t idx, u8 * data, size_t len);

void byte_array_destroy(byte_array * orig);

size_t byte_array_delete(byte_array *, size_t, size_t);

#define BYTE_ARRAY_ALLOCA(n) \
    n = (byte_array *) alloca(sizeof(byte_array)); \
    memset(n, 0, sizeof(byte_array));

#endif
