/* Copyright (c) 2001 Michael Wolf.  All rights reserved.  
 *
 * This file is part of moodns.
 *
 * moodns is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version. 
 *
 * moodns is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with moodns; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Header: /cvsroot/moodns/moodns/code/sockcat/misc.c,v 1.1 2002/07/20 16:46:58 mawolf Exp $  */

#ifndef _REENTRANT
#define _REENTRANT
#endif

#include <stdlib.h>
#ifdef HAVE_ALLOCA_H
#include <alloca.h>
#endif
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>


// #include "protocol.h"
#include "record.h"
#include "misc.h"

extern record_chain *roots;

void
initialise_roots()
{
    struct in_addr x;
    record *t;
    int i; //, ret;   
    // const char *global_roots[] = {
    // "198.41.0.4", "128.9.0.107", "192.33.4.12", "128.8.10.90",
    // "192.203.230.10", "192.5.5.241", "192.112.36.4", "128.63.2.53",
    // "192.36.148.17","198.41.0.10", "193.0.14.129", "198.32.64.12",
    // "202.12.27.33", NULL
    // };
    const char *global_roots[] = { "192.168.0.15", NULL };

    roots = record_chain_init(strdupa(".")); // stupid discards qualified warning
    
    for (i = 0; ; ++i) {
        if (global_roots[i] == NULL)
            break;
        t = record_alloc();
        t->type = A;
        strncpy(t->name, ".", 256);
        inet_aton(global_roots[i], &x);
        t->record.a = x.s_addr;
        record_chain_add(roots, t);
    }
}


/* One some systems htons etc are defined as macros, which means we can't 
   call them from the debugger.  We can call these, however.  */

u32 
bogo_htonl(u32 h)
{
    return bogo_ntohl(h);
}

u32
bogo_ntohl(u32 h)
{
    return ntohl(h);
}

u16
bogo_htons(u16 h)
{
    return bogo_ntohs(h);
}

u16
bogo_ntohs(u16 h)
{
    return ntohs(h);
}

void
pname(u32 ip)
{
    struct in_addr foo;
    foo.s_addr = ip;
    printf("%s\n", inet_ntoa(foo));
}
