/* Copyright (c) 2001 Michael Wolf.  All rights reserved. 
 *
 * This file is part of moodns.
 *
 * moodns is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version. 
 *
 * moodns is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with moodns; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
    
/* $Header: /cvsroot/moodns/moodns/code/sockcat/mtime.c,v 1.1 2002/07/20 16:46:58 mawolf Exp $  */
    
#ifndef _REENTRANT
#define _REENTRANT
#endif

#if HAVE_CONFIG_H
#include "../config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <unistd.h>

#include <sys/time.h>

#include <pthread.h>

#include "mtime.h"

#include "xmalloc.h"
#if WITH_DMALLOC
#include <dmalloc.h>
#endif

u32
now()
{
    unsigned int retval;
    int ret;
    struct timeval tv;

    ret = gettimeofday(&tv, NULL);
    if (ret != 0) {
        perror("gettimeofday() failed");
        abort();
    }
    retval = tv.tv_sec + tv.tv_usec / 1000000;

    return retval;
}

u32
future(u32 present, u32 ttl)
{
    return present + ttl;
}

int
past(u32 then)
{
    u32 n;

    n = now();
    if (n > then)
        return 1;
    else
        return 0;
}
