/* Copyright (c) 2002, Michael Wolf.  All rights reserved.  */
/* Copyright (c) 2002, Ximian Inc.  All rights reserved.  */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>

#include "util.h"



/* die is meant to alert user errors.  */

void
die(const char *fmt, ...)
{
    va_list ap;
    
    va_start(ap, fmt);
    vfprintf(stderr, fmt, ap);
    va_end(ap);
    exit(1);
}

/* croak is meant to alert internal errors.  */

void
croak(const char *fmt, ...)
{
    va_list ap;
    va_start(ap, fmt);
    vfprintf(stderr, fmt, ap);
    va_end(ap);
    abort();
}

void
printf_on_debug(const char *fmt __attribute__((unused)), ...)
{
#ifdef DEBUG
    va_list ap;
    va_start(ap, fmt);
    vfprintf(stderr, fmt, ap);
    va_end(ap);
#endif
}
