/* Copyright (c) 2001 Michael A Wolf.  All rights reserved.

This file is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2, or (at your option) any later
version.

This file is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
Public License for more details.

You should have received a copy of the GNU General Public License along
with this file; see the file COPYING.  If not, write to the 
Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.  */

/* $Header: /cvsroot/moodns/moodns/code/sockcat/xmalloc.h,v 1.1 2002/07/20 16:46:58 mawolf Exp $  */

#ifndef XMALLOC_H 
#define XMALLOC_H

#if HAVE_CONFIG_H
# include "../config.h"
#endif

#include <stdlib.h>

#if WITH_DMALLOC
# define xmalloc(n) malloc(n)
# define xcalloc(n, m) calloc(n, m)
# define xrealloc(p, s) realloc(p, s)
# define xfree(p) free(p)
# define xstrdup(p) strdup(p)
#else
# define xmalloc(n) wmalloc(n, __FILE__, __LINE__)
# define xcalloc(n, m) wcalloc(n, m, __FILE__, __LINE__)
# define xrealloc(p, s) wrealloc(p, s, __FILE__, __LINE__)
# define xfree(p) wfree(p, __FILE__, __LINE__)
# define xstrdup(p) wstrdup(p, __FILE__, __LINE__)
#endif

void *wmalloc(size_t, const char *, int);
void *wcalloc(size_t, size_t, const char *, int);
void *wrealloc(void *, size_t, const char *, int);
void wfree(void *, const char *, int);
char *wstrdup(const char *, const char *, int);

#endif /* XMALLOC_H  */

