/* Copyright (c) 2002 Michael Wolf.  All rights reserved.  
 *
 * This file is part of moodns.
 * 
 * moodns is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version. 
 * 
 * moodns is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with moodns; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
/* $Header: /cvsroot/moodns/moodns/src/database.c,v 1.4 2002/02/01 06:15:15 mawolf Exp $  */

#ifndef _REENTRANT
#define _REENTRANT
#endif


/* #include <ltdl.h>  */
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <pthread.h>

#include "wpthread.h"
#include "misc.h"
#include "record.h"
#include "database.h"
#include "options.h"

#include "xmalloc.h"
#ifdef WITH_DMALLOC
# include <dmalloc.h>
#endif

/* extern pthread_mutex_t ltdl_mutex;  */

extern struct global_options globals;
/* So what functions do we need?  */



/* We try to initialise a database to load a module and with that module to
   load a path.  */
database *
database_init(char *file_path __attribute__((unused)))
{
    database /*_generic*/ *retval;
    retval = (database *) xcalloc(1, sizeof(database));

    database_module_init(retval);

    return retval;
}

void 
database_generic_set_type_function(database_generic *dg, 
                                   enum database_type (*func)(void))
{
    dg->type_func = func;
}


#ifdef TEST

#include <stdio.h>
#include <string.h>

#include "options.h"

struct global_options globals;

/* Usually this is found in main.c  */
pthread_mutex_t ltdl_mutex = PTHREAD_MUTEX_INITIALIZER;
int
main(int argc, char **argv)
{
    lt_dlhandle foo;
    char *x;
    lt_ptr_t bar;
    database *d;
    int ret;

    memset(&globals, 0, sizeof(globals));

    lt_dlinit();
    if (globals.general.modules_path != NULL)
        lt_dlsetsearchpath(globals.general.modules_path);

    if (argc != 2) {
        printf("We need a second argument as the name of a module to be loaded\n");
        exit (1);
    }
    x = (char *) alloca(strlen("./") + strlen(argv[1]) + 1); 
    strcpy(x, "./");
    strcat(x, argv[1]);
    foo = lt_dlopen(x);
    if (foo == NULL) {
        printf("Unable to open %s: %s\n", x, lt_dlerror());
        exit(2);
    }

    bar = lt_dlsym(foo, "hello_module");
    if (bar == NULL) {
        printf("Unable to locate symbol %s: %s\n", "hello_module", lt_dlerror());
    } else {
        ((void (*)(void) ) bar)();
    }
    lt_dlexit();

    foo = lt_dlopen(x);
    d = database_init(x);
    bar = lt_dlsym(foo, "database_module_init");
    if (bar == NULL) {
        printf("Unable to locate symbol %s: %s\n", "database_module_init", 
               lt_dlerror());
    } else {
        ret = ((int (*)(database *)) bar)(d);
        printf("ret is %d\n", ret);

        d->open_file(d, "../doc/data");

    }
    
    

    return 0;    
}

#endif
