/*
 * Simple, robust hash table implementation.  
 *
 * Copyright (c) 2001 Michael Wolf (mike@dodgysoftware.net)
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


/* $Header: /cvsroot/moodns/moodns/src/ht.h,v 1.1.1.1 2001/12/21 02:43:04 mawolf Exp $  */

#ifndef HT_H
#define HT_H

struct ht;
typedef struct ht ht;

ht *ht_init(int (*)(void *, void *, void *), void (*)(void *, void *));
int ht_put(ht *, char *, void *, void *);
void *ht_get(ht *, char *);
void ht_iterate(ht *, void (*)(char *, void *, void *), void *);
void *ht_remove(ht *, char *);
void ht_destroy(ht *, void (*)(char *, void *, void *), void *);

void ht_set_get_hook(ht *, void (*)(char *, void *, void *), void *);
void ht_set_put_hook(ht *, void (*)(char *, void *, void *), void *);

void ht_debug_dump(ht *, void (*)(void *));
#endif 






