/* Copyright (c) 2002, Michael Wolf.  All rights reserved.  */

/* usage: moocache -p path -n maxclients  */

/* do we want to limit the max number of clients here, with mooinet, or both?
   i think both is the correct answer.  */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>

#include "byte_array.h"
#include "socket.h"
#include "cache.h"
#include "util.h"

#include "xmalloc.h"
#ifdef DMALLOC
#include <dmalloc.h>
#endif

socket_t *incoming(void);
int loop(socket_t *);

char *cachesock_path = NULL;
int maxclients = -1;

cache *c;

int
main(int argc, char **argv)
{
    int retval;
    int x;
    socket_t *s;

    while ((x = getopt(argc, argv, "c:n:h")) != -1) {
        switch (x) {
        case 'c':
            cachesock_path = xstrdup(optarg);
            break;
        case 'n':
            maxclients = strtol(optarg, NULL, 10);
            break;
        case 'h':
            printf("usage: moocache -c path -n maxclients -h\n");
            exit(1);
        }
    }

    c = cache_init_st();
    if (c == NULL)
        croak("cache initialisation failed");
    s = incoming();
    if (s == NULL)
        croak("socket initialisation failed");

    retval = loop(s);
    
    
    return retval;
}

socket_t *
incoming()
{
    socket_address_t s;
    memset(&s, 0, sizeof(s));
    s.local.path = cachesock_path;
    return socket_listener(&s, SOCKET_LOCAL, SOCKET_STREAM);
}

int
loop(socket_t *s)
{
    int ret;
    fd_set r;
    struct timeval tv;
    
    while (1) {
        FD_ZERO(&r);
        tv.tv_sec = 10;
        tv.tv_usec = 0;
        
        ret = select(s->fd + 1, &r, NULL, NULL, &tv);
        
        
    }
    return 0;    
}

