/* Copyright (c) 2001 Michael Wolf.  All rights reserved. 
 *
 * This file is part of moodns.
 * 
 * moodns is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version. 
 *
 * moodns is distributed in the hope that it will be useful,   
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with moodns; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 
  
/* $Header: /cvsroot/moodns/moodns/src/options.h,v 1.5 2002/01/17 13:10:25 mawolf Exp $  */

#ifndef OPTIONS_H
#define OPTIONS_H

struct global_options {
    struct {
        int num_threads;
        int general_use_logging;
        int general_logging_interval;
        char *general_logging_path;
        int use_modules;
        char *modules_path;
    } general;
    
    struct {
        char *user_name;
        char *directory;
    } security;

    struct {
        int port;
        unsigned int ip;
        int use_tcp;
        int use_udp;
    } net;

    struct {
        int use_cache;
        int num_cached;
        int cache_use_logging;
        int cache_logging_interval;
        char *cache_logging_path;
    } cache;

    struct {
        int use_authoritative;
        char *datafile;
        int default_ttl;
        int authoritative_use_logging;
        int authoritative_logging_interval;
        char *authoritative_logging_path;
    } authoritative;

};

/* Call this as many times as you like.  See if I care.  */
void options_init(void);

#endif
