/* this file is slated to be removed from moodns.  */

/* 
 * Part of the pthread_utils package.  
 *
 * Copyright (c) 2001 Michael Wolf.  All rights reserved.  
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* $Header: /cvsroot/moodns/moodns/src/recursive_mutex.c,v 1.3 2002/07/20 17:01:51 mawolf Exp $  */

#ifndef _REENTRANT
#define _REENTRANT
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include "wpthread.h" 

#include "recursive_mutex.h"


struct recursive_mutex {
    pthread_mutex_t mutex;
    pthread_cond_t cv;
    pthread_t owner;
    int depth;
};

recursive_mutex *
recursive_mutex_init()
{
    return recursive_mutex_init_alloc(malloc);
}

recursive_mutex *
recursive_mutex_init_alloc(void *(*alloc_func)(size_t))
{
    recursive_mutex *retval;

    retval = (*alloc_func)(sizeof(recursive_mutex));
    wpthread_mutex_init(&retval->mutex, NULL);
    wpthread_cond_init(&retval->cv, NULL);
    retval->depth = 0;

    return retval;
}

int
recursive_mutex_lock(recursive_mutex *rm)
{
    int retval = 0;
    pthread_t self;
    self = pthread_self();
    pthread_mutex_lock(&rm->mutex);
    if (rm->depth > 0) {
        while (rm->depth > 0) {
            pthread_cond_wait(&rm->cv, &rm->mutex);
        }
        assert(rm->depth == 0);
        rm->depth++;
        rm->owner = self;
    } else {
        rm->depth++;
    }
    pthread_mutex_unlock(&rm->mutex);

    return retval;
}
