/* Copyright (c) 2002 Ximian, Inc.  All rights reserved.  */
/* By Michael Wolf <maw@ximian.com>  */

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <errno.h>
#include <assert.h>

#include "safewait.h"

int
safewait(pid_t pid, int *status, int options, struct rusage *ru, 
         int safewait_options __attribute__((unused)), int timeout)
{
    int retval;
    pid_t p;
    
    if (timeout <= 0) {
        /* Do setitimer crap.  */  /* XXX: Implement this.  */
    }
    
    do {
        p = wait4(pid, status, options, ru);
    } while ((pid == -1) && (errno == EINTR));
    if (p == -1)
        retval = 0;
    else
        retval = 1;
    return retval;
}
