/* Copyright (c) 2002 Ximian, Inc.  All rights reserved.  
   Copyright (c) 2002 Michael Wolf.  All rights reserved.  

   This file is part of moodns.

   moodns is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version. 
   
   moodns is distributed in the hope that it will be useful,  
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with moodns; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>

extern char **environ; /* Aarrgh!  */

#include "safewait.h"
#include "spawn.h"

int
spawn(char **command, char **envp)
{
    int retval;
    pid_t pid;
    int status;
    int ret;
    struct rusage ru;

    pid = fork();
    switch (pid) {
    case -1:
        abort();
        break;
    case 0:
        // exect(command[0], command, envp);
        if (envp != NULL) {
            environ = envp;
        }
        ret = execv(command[0], command);
        printf("unable to launch %s: %s\n", command[0], strerror(errno));
        exit(EXIT_FAILURE);
        break;
    default:
        safewait(pid, &status, 0, &ru, 0, -1);
        break;
    }
    
    return retval;
}
